/*
 * (C) 2001 Clemson University
 *
 * See COPYING in top-level directory.
 */


#ifndef _SYMBOL_H_
#define _SYMBOL_H_

#ifndef lint
static char symbol_h_rcsid[] = "$Header: /projects/cvsroot/coven-module-parser/symbol.h,v 1.3 2003/01/28 14:53:35 ndebard Exp $";
#endif

/*
 *	symbol.h --- declarations for all the public types
 */

#define TYPE_MODULE 0x1
#define TYPE_VARIABLE 0x2	
#define TYPE_ARGUMENT 0x3	
#define TYPE_TYPE 0x4

typedef struct argument_ent
{
	char *name;
	int direction;
	int mclass;
	struct sym_ent *type;
} argument_ent, *argument_ent_p;

typedef struct module_ent
{
	char *path;
	struct sym_ent *args;
} module_ent, *module_ent_p;

typedef struct variable_ent
{
	int vclass;
	struct sym_ent *type;
} variable_ent, *variable_ent_p;

typedef union type_ent
{
	void *v;
	module_ent_p mod;
	variable_ent_p var;
	argument_ent_p arg;
} type_ent, *type_ent_p;

typedef struct sym_ent
{
	char *name;		/* ptr to string table */
	int type;
	union type_ent value;	/* sybmol record */
	struct sym_ent *next;	/* next in line */
} sym_ent, *sym_ent_p;

sym_ent_p symenter(char *name, sym_ent_p context, int type);
sym_ent_p symlook(char *name, sym_ent_p context, int type);
sym_ent_p lookup_type(char *name);
void init_symbol_table();

#endif

